Index: /utils/CI/sette/sette_reference-configurations.sh
===================================================================
--- /utils/CI/sette/sette_reference-configurations.sh	(revision 11496)
+++ /utils/CI/sette/sette_reference-configurations.sh	(revision 11497)
@@ -162,5 +162,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n GYRE_PISCES_ST -r GYRE_PISCES -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n GYRE_PISCES_ST -r GYRE_PISCES -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -302,5 +302,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ORCA2_ICE_PISCES_ST -r ORCA2_ICE_PISCES -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ORCA2_ICE_PISCES_ST -r ORCA2_ICE_PISCES -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -543,5 +543,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ORCA2_OFF_PISCES_ST -r ORCA2_OFF_PISCES -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ORCA2_OFF_PISCES_ST -r ORCA2_OFF_PISCES -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -733,5 +733,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n AMM12_ST -r AMM12 -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n AMM12_ST -r AMM12 -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -860,5 +860,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ORCA2_SAS_ICE_ST -r ORCA2_SAS_ICE -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ORCA2_SAS_ICE_ST -r ORCA2_SAS_ICE -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1112,5 +1112,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n AGRIF_DEMO_ST -r AGRIF_DEMO -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n AGRIF_DEMO_ST -r AGRIF_DEMO -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1381,5 +1381,5 @@
     export TEST_NAME="ORCA2"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n AGRIF_DEMO_NOAGRIF_ST -r AGRIF_DEMO -j 8 add_key ${ADD_KEYS} del_key "key_agrif"
+    . ./makenemo -m ${CMP_NAM} -n AGRIF_DEMO_NOAGRIF_ST -r AGRIF_DEMO -j 8 add_key "${ADD_KEYS}" del_key "key_agrif"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1418,5 +1418,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n SPITZ12_ST -r SPITZ12 -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n SPITZ12_ST -r SPITZ12 -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
Index: /utils/CI/sette/sette_rpt.sh
===================================================================
--- /utils/CI/sette/sette_rpt.sh	(revision 11496)
+++ /utils/CI/sette/sette_rpt.sh	(revision 11497)
@@ -15,6 +15,9 @@
     dorv=`ls -1rt $vdir/$nam/$mach/ | tail -1l `
     dorv=`echo $dorv | sed -e 's:.*/::'`
+    dorv2=`ls -1rt $vdir/$nam2/$mach/ | tail -1l `
+    dorv2=`echo $dorv2 | sed -e 's:.*/::'`
   else
     dorv=$lastchange
+    dorv2=$lastchange
   fi
 }
@@ -364,55 +367,39 @@
 function identictest(){
 #
-#  checks AGRIF does not corrupe results with no AGRIF zoom. Expects ORCA2AGUL/AGRIFNOZ and ORCA2AGUL_NAGR/AGRIFNO  run directories
-# Compares solver.stat files for each
+# Checks AGRIF does not corrupt results with no AGRIF zoom by comparing run.stat files
 #
   vdir=$1
-  dir1=$2
-  dir2=$3
+  nam=$2
+  nam2=$3
   pass=$4
 #
-  if [ -d $vdir/$dir1 ] && [ -d $vdir/$dir2 ]; then
-    dorv1=`ls -1rt $vdir/$dir1/$mach/ | tail -1l `
-    dorv1=`echo $dorv1 | sed -e 's:.*/::'`
-    dorv2=`ls -1rt $vdir/$dir2/$mach/ | tail -1l `
-    dorv2=`echo $dorv2 | sed -e 's:.*/::'`
-
-    rep1=`ls -1rt $vdir/$dir1/$mach/$dorv1/ |  tail -1l`
-#clem    rep2=`ls -1rt $vdir/$dir2/$mach/$dorv2/ |  tail -1l`
-    rep2=`ls -1rt $vdir/$dir1/$mach/$dorv1/ |  tail -1l`
-    f1s=$vdir/$dir1/$mach/$dorv1/$rep1/run.stat
-    f2s=$vdir/$dir2/$mach/$dorv2/$rep2/run.stat
-
-    if  [ ! -f $f1s ] && [ ! -f $f2s ] ; then 
-      printf "%-27s %s\n" $dir1 $dir2 " incomplete test";
-      return; 
-    fi
-#
-    done_oce=0
-
-    if  [ -f $f1s ] && [ -f $f2s ] ; then
+  get_dorv
+#
+  rep=`ls -1rt $vdir/$nam/$mach/$dorv/ |  tail -1l`
+  f1s=${vdir}/${nam}/${mach}/${dorv}/${rep}/run.stat
+  f2s=${vdir}/${nam2}/${mach}/${dorv2}/${rep}/run.stat
+#
+  if  [ -f $f1s ] && [ -f $f2s ] ; then
       cmp -s $f1s $f2s
       if [ $? == 0 ]; then
-        if [ $pass == 0 ]; then 
-          printf "%-5s %s %-5s %s %s %s\n" $rep1 "AGRIF vs" $rep2 "NOAGRIF run.stat    unchanged  -    passed : " $dorv1 $dorv2
-        fi
-      else
-        get_ktdiff $f1s $f2s
-        printf "\e[38;5;196m%-5s %s %-5s %s %s %s %s %-5s %s\e[0m\n" $rep1 "AGRIF vs" $rep2 "NOAGRIF run.stat    changed  -     FAILED : " $dorv1 $dorv2 " (results are different after " $ktdiff " time steps)"
-#
-# Offer view of differences on the second pass
-#
-        if [ $pass == 1 ]; then
-          echo "<return> to view run.stat differences"
-          read y
-          sdiff $f1s $f2s
-          done_oce=1
-          echo "<return> to continue"
-          read y
-        fi
-      fi
-    fi
+          if [ $pass == 0 ]; then 
+	      printf "%-5s %s %-5s %s %s %s\n" $rep "AGRIF vs" $rep "NOAGRIF run.stat    unchanged  -    passed : " $dorv $dorv2
+          fi
+      else
+          get_ktdiff $f1s $f2s
+          printf "\e[38;5;196m%-5s %s %-5s %s %s %s %s %-5s %s\e[0m\n" $rep "AGRIF vs" $rep "NOAGRIF run.stat    changed  -     FAILED : " $dorv $dorv2 " (results are different after " $ktdiff " time steps)"
+#
+# Offer view of differences on the second pass
+#
+          if [ $pass == 1 ]; then
+	      echo "<return> to view run.stat differences"
+	      read y
+	      sdiff $f1s $f2s
+	      echo "<return> to continue"
+	      read y
+          fi
+      fi
   else
-    printf "%-27s %s\n" $dir1 $dir2 " incomplete test";
+      printf "%-27s %-27s %s\n" $nam $nam2 " incomplete test"
   fi
 }
Index: /utils/CI/sette/sette_test-cases.sh
===================================================================
--- /utils/CI/sette/sette_test-cases.sh	(revision 11496)
+++ /utils/CI/sette/sette_test-cases.sh	(revision 11497)
@@ -164,5 +164,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n OVERFLOW_ST -a OVERFLOW -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n OVERFLOW_ST -a OVERFLOW -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -261,5 +261,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n LOCK_EXCHANGE_ST -a LOCK_EXCHANGE -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n LOCK_EXCHANGE_ST -a LOCK_EXCHANGE -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -359,5 +359,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n VORTEX_ST -a VORTEX -j 8  add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n VORTEX_ST -a VORTEX -j 8  add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -536,5 +536,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ICE_AGRIF_ST -a ICE_AGRIF -j 8  add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ICE_AGRIF_ST -a ICE_AGRIF -j 8  add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -721,5 +721,5 @@
     export TEST_NAME="LONG"
     cd ${MAIN_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ISOMIP_ST -a ISOMIP -j 8 add_key ${ADD_KEYS} del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ISOMIP_ST -a ISOMIP -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg