Index: /NEMO/branches/2019/dev_r10984_HPC-13_IRRMANN_BDY_optimization/cfgs/SHARED/namelist_ref
===================================================================
--- /NEMO/branches/2019/dev_r10984_HPC-13_IRRMANN_BDY_optimization/cfgs/SHARED/namelist_ref	(revision 11509)
+++ /NEMO/branches/2019/dev_r10984_HPC-13_IRRMANN_BDY_optimization/cfgs/SHARED/namelist_ref	(revision 11510)
@@ -639,7 +639,9 @@
    bn_s_i      = 'NOT USED'              ,         24.       , 'iicesalt',    .true.   , .false.,  'daily'  ,    ''            ,   ''     ,     ''
    ! if bn_t_i, bn_tsu and bn_s_i are "not used", then define arbitrary temperatures and salinity
-   rn_ice_tem    = 270.       !  arbitrary temperature of incoming sea ice
-   rn_ice_sal    = 10.        !       --   salinity           --
-   rn_ice_age    = 30.        !       --   age                --
+   rn_ice_tem  = 270.         !  arbitrary temperature of incoming sea ice
+   rn_ice_sal  = 10.          !       --   salinity           --
+   rn_ice_age  = 30.          !       --   age                --
+   rn_ice_apnd = 0.2          !       --   pond conc.         --
+   rn_ice_hpnd = 0.05         !       --   pond depth         --
 /
 !-----------------------------------------------------------------------
Index: /NEMO/branches/2019/dev_r10984_HPC-13_IRRMANN_BDY_optimization/src/OCE/BDY/bdy_oce.F90
===================================================================
--- /NEMO/branches/2019/dev_r10984_HPC-13_IRRMANN_BDY_optimization/src/OCE/BDY/bdy_oce.F90	(revision 11509)
+++ /NEMO/branches/2019/dev_r10984_HPC-13_IRRMANN_BDY_optimization/src/OCE/BDY/bdy_oce.F90	(revision 11510)
@@ -111,4 +111,6 @@
    REAL(wp), DIMENSION(jp_bdy) ::   rice_sal                !: salinity    of incoming sea ice
    REAL(wp), DIMENSION(jp_bdy) ::   rice_age                !: age         of incoming sea ice
+   REAL(wp), DIMENSION(jp_bdy) ::   rice_apnd               !: pond conc.  of incoming sea ice
+   REAL(wp), DIMENSION(jp_bdy) ::   rice_hpnd               !: pond thick. of incoming sea ice
    !
    !!----------------------------------------------------------------------
Index: /NEMO/branches/2019/dev_r10984_HPC-13_IRRMANN_BDY_optimization/src/OCE/BDY/bdydta.F90
===================================================================
--- /NEMO/branches/2019/dev_r10984_HPC-13_IRRMANN_BDY_optimization/src/OCE/BDY/bdydta.F90	(revision 11509)
+++ /NEMO/branches/2019/dev_r10984_HPC-13_IRRMANN_BDY_optimization/src/OCE/BDY/bdydta.F90	(revision 11510)
@@ -362,5 +362,5 @@
       !                                                         ! =F => baroclinic velocities in 3D boundary data
       LOGICAL                                ::   ln_zinterp    ! =T => requires a vertical interpolation of the bdydta
-      REAL(wp)                               ::   rn_ice_tem, rn_ice_sal, rn_ice_age
+      REAL(wp)                               ::   rn_ice_tem, rn_ice_sal, rn_ice_age, rn_ice_apnd, rn_ice_hpnd 
       INTEGER                                ::   ipk,ipl       !
       INTEGER                                ::   idvar         ! variable ID
@@ -380,5 +380,5 @@
       NAMELIST/nambdy_dta/ cn_dir, bn_tem, bn_sal, bn_u3d, bn_v3d, bn_ssh, bn_u2d, bn_v2d 
       NAMELIST/nambdy_dta/ bn_a_i, bn_h_i, bn_h_s, bn_t_i, bn_t_s, bn_tsu, bn_s_i
-      NAMELIST/nambdy_dta/ rn_ice_tem, rn_ice_sal, rn_ice_age
+      NAMELIST/nambdy_dta/ rn_ice_tem, rn_ice_sal, rn_ice_age, rn_ice_apnd, rn_ice_hpnd
       NAMELIST/nambdy_dta/ ln_full_vel, ln_zinterp
       !!---------------------------------------------------------------------------
@@ -434,8 +434,10 @@
          ENDIF
 
-         ! temp, sal and age of incoming ice
-         rice_tem(jbdy) = rn_ice_tem
-         rice_sal(jbdy) = rn_ice_sal
-         rice_age(jbdy) = rn_ice_age
+         ! temp, salt, age and ponds of incoming ice
+         rice_tem (jbdy) = rn_ice_tem
+         rice_sal (jbdy) = rn_ice_sal
+         rice_age (jbdy) = rn_ice_age
+         rice_apnd(jbdy) = rn_ice_apnd
+         rice_hpnd(jbdy) = rn_ice_hpnd
          
          
Index: /NEMO/branches/2019/dev_r10984_HPC-13_IRRMANN_BDY_optimization/src/OCE/BDY/bdyice.F90
===================================================================
--- /NEMO/branches/2019/dev_r10984_HPC-13_IRRMANN_BDY_optimization/src/OCE/BDY/bdyice.F90	(revision 11509)
+++ /NEMO/branches/2019/dev_r10984_HPC-13_IRRMANN_BDY_optimization/src/OCE/BDY/bdyice.F90	(revision 11510)
@@ -225,11 +225,15 @@
                   !
                CASE( 0 )   ! velocity is inward
-                  oa_i(ji,jj,jl) = rice_age(jbdy) * a_i(ji,jj,jl)   ! age
-                  a_ip(ji,jj,jl) = 0._wp                            ! pond concentration
-                  v_ip(ji,jj,jl) = 0._wp                            ! pond volume
+                  oa_i(ji,jj,jl) = rice_age(jbdy) * a_i(ji,jj,jl)     ! age
+                  IF( ln_pnd_CST .OR. ln_pnd_H12 ) THEN
+                     a_ip(ji,jj,jl) = rice_apnd(jbdy)                 ! pond concentration
+                     v_ip(ji,jj,jl) = rice_apnd(jbdy)*rice_hpnd(jbdy) ! pond volume
+                  ENDIF
                CASE( 1 )   ! velocity is outward
-                  oa_i(ji,jj,jl) = oa_i(ib,jb,jl) ! age
-                  a_ip(ji,jj,jl) = a_ip(ib,jb,jl) ! pond concentration
-                  v_ip(ji,jj,jl) = v_ip(ib,jb,jl) ! pond volume
+                  oa_i(ji,jj,jl) = oa_i(ib,jb,jl)                     ! age
+                  IF( ln_pnd_CST .OR. ln_pnd_H12 ) THEN
+                     a_ip(ji,jj,jl) = a_ip(ib,jb,jl)                  ! pond concentration
+                     v_ip(ji,jj,jl) = v_ip(ib,jb,jl)                  ! pond volume
+                  ENDIF
                END SELECT
                !