Index: NEMO/branches/2019/dev_r10984_HPC-13_IRRMANN_BDY_optimization/doc/latex/NEMO/subfiles/chap_model_basics.tex
===================================================================
--- NEMO/branches/2019/dev_r10984_HPC-13_IRRMANN_BDY_optimization/doc/latex/NEMO/subfiles/chap_model_basics.tex	(revision 11353)
+++ NEMO/branches/2019/dev_r10984_HPC-13_IRRMANN_BDY_optimization/doc/latex/NEMO/subfiles/chap_model_basics.tex	(revision 11512)
@@ -1,2 +1,3 @@
+
 \documentclass[../main/NEMO_manual]{subfiles}
 
@@ -8,5 +9,6 @@
 \chapter{Model Basics}
 \label{chap:PE}
-\minitoc
+
+\chaptertoc
 
 \newpage
@@ -19,5 +21,5 @@
 
 % -------------------------------------------------------------------------------------------------------------
-%        Vector Invariant Formulation 
+%        Vector Invariant Formulation
 % -------------------------------------------------------------------------------------------------------------
 
@@ -26,5 +28,5 @@
 
 The ocean is a fluid that can be described to a good approximation by the primitive equations,
-\ie the Navier-Stokes equations along with a nonlinear equation of state which
+\ie\ the Navier-Stokes equations along with a nonlinear equation of state which
 couples the two active tracers (temperature and salinity) to the fluid velocity,
 plus the following additional assumptions made from scale considerations:
@@ -34,6 +36,6 @@
   \textit{spherical Earth approximation}: the geopotential surfaces are assumed to be oblate spheriods
   that follow the Earth's bulge; these spheroids are approximated by spheres with
-  gravity locally vertical (parallel to the Earth's radius) and independent of latitude 
-  \citep[][section 2]{white.hoskins.ea_QJRMS05}.   
+  gravity locally vertical (parallel to the Earth's radius) and independent of latitude
+  \citep[][section 2]{white.hoskins.ea_QJRMS05}.
 \item
   \textit{thin-shell approximation}: the ocean depth is neglected compared to the earth's radius
@@ -65,10 +67,10 @@
     \nabla \cdot \vect U = 0
   \end{equation}
- \item 
-  \textit{Neglect of additional Coriolis terms}: the Coriolis terms that vary with the cosine of latitude are neglected. 
+ \item
+  \textit{Neglect of additional Coriolis terms}: the Coriolis terms that vary with the cosine of latitude are neglected.
   These terms may be non-negligible where the Brunt-Vaisala frequency $N$ is small, either in the deep ocean or
-  in the sub-mesoscale motions of the mixed layer, or near the equator \citep[][section 1]{white.hoskins.ea_QJRMS05}. 
-  They can be consistently included as part of the ocean dynamics \citep[][section 3(d)]{white.hoskins.ea_QJRMS05} and are 
-  retained in the MIT ocean model.     
+  in the sub-mesoscale motions of the mixed layer, or near the equator \citep[][section 1]{white.hoskins.ea_QJRMS05}.
+  They can be consistently included as part of the ocean dynamics \citep[][section 3(d)]{white.hoskins.ea_QJRMS05} and are
+  retained in the MIT ocean model.
 \end{enumerate}
 
@@ -76,7 +78,7 @@
 it is useful to choose an orthogonal set of unit vectors $(i,j,k)$ linked to the Earth such that
 $k$ is the local upward vector and $(i,j)$ are two vectors orthogonal to $k$,
-\ie tangent to the geopotential surfaces.
+\ie\ tangent to the geopotential surfaces.
 Let us define the following variables: $\vect U$ the vector velocity, $\vect U = \vect U_h + w \, \vect k$
-(the subscript $h$ denotes the local horizontal vector, \ie over the $(i,j)$ plane), 
+(the subscript $h$ denotes the local horizontal vector, \ie\ over the $(i,j)$ plane),
 $T$ the potential temperature, $S$ the salinity, $\rho$ the \textit{in situ} density.
 The vector invariant form of the primitive equations in the $(i,j,k)$ vector system provides
@@ -115,7 +117,7 @@
 an air-sea or ice-sea interface at its top.
 These boundaries can be defined by two surfaces, $z = - H(i,j)$ and $z = \eta(i,j,k,t)$,
-where $H$ is the depth of the ocean bottom and $\eta$ is the height of the sea surface 
-(discretisation can introduce additional artificial ``side-wall'' boundaries). 
-Both $H$ and $\eta$ are referenced to a surface of constant geopotential (\ie a mean sea surface height) on which $z = 0$. 
+where $H$ is the depth of the ocean bottom and $\eta$ is the height of the sea surface
+(discretisation can introduce additional artificial ``side-wall'' boundaries).
+Both $H$ and $\eta$ are referenced to a surface of constant geopotential (\ie\ a mean sea surface height) on which $z = 0$.
 (\autoref{fig:ocean_bc}).
 Through these two boundaries, the ocean can exchange fluxes of heat, fresh water, salt, and momentum with
@@ -153,10 +155,10 @@
   \footnote{
     In fact, it has been shown that the heat flux associated with the solid Earth cooling
-    (\ie the geothermal heating) is not negligible for the thermohaline circulation of the world ocean
+    (\ie\ the geothermal heating) is not negligible for the thermohaline circulation of the world ocean
     (see \autoref{subsec:TRA_bbc}).
   }.
   The boundary condition is thus set to no flux of heat and salt across solid boundaries.
   For momentum, the situation is different. There is no flow across solid boundaries,
-  \ie the velocity normal to the ocean bottom and coastlines is zero (in other words,
+  \ie\ the velocity normal to the ocean bottom and coastlines is zero (in other words,
   the bottom velocity is parallel to solid boundaries). This kinematic boundary condition
   can be expressed as:
@@ -221,7 +223,7 @@
 the time step has to be very short when they are present in the model.
 The latter strategy filters out these waves since the rigid lid approximation implies $\eta = 0$,
-\ie the sea surface is the surface $z = 0$.
+\ie\ the sea surface is the surface $z = 0$.
 This well known approximation increases the surface wave speed to infinity and
-modifies certain other longwave dynamics (\eg barotropic Rossby or planetary waves).
+modifies certain other longwave dynamics (\eg\ barotropic Rossby or planetary waves).
 The rigid-lid hypothesis is an obsolescent feature in modern OGCMs.
 It has been available until the release 3.1 of \NEMO, and it has been removed in release 3.2 and followings.
@@ -246,5 +248,5 @@
 Allowing the air-sea interface to move introduces the external gravity waves (EGWs) as
 a class of solution of the primitive equations.
-These waves are barotropic (\ie nearly independent of depth) and their phase speed is quite high.
+These waves are barotropic (\ie\ nearly independent of depth) and their phase speed is quite high.
 Their time scale is short with respect to the other processes described by the primitive equations.
 
@@ -275,5 +277,5 @@
 the implicit scheme \citep{dukowicz.smith_JGR94} or
 the addition of a filtering force in the momentum equation \citep{roullet.madec_JGR00}.
-With the present release, \NEMO  offers the choice between
+With the present release, \NEMO\  offers the choice between
 an explicit free surface (see \autoref{subsec:DYN_spg_exp}) or
 a split-explicit scheme strongly inspired the one proposed by \citet{shchepetkin.mcwilliams_OM05}
@@ -293,5 +295,5 @@
 
 In many ocean circulation problems, the flow field has regions of enhanced dynamics
-(\ie surface layers, western boundary currents, equatorial currents, or ocean fronts).
+(\ie\ surface layers, western boundary currents, equatorial currents, or ocean fronts).
 The representation of such dynamical processes can be improved by
 specifically increasing the model resolution in these regions.
@@ -313,5 +315,5 @@
 $(i,j,k)$ linked to the earth such that
 $k$ is the local upward vector and $(i,j)$ are two vectors orthogonal to $k$,
-\ie along geopotential surfaces (\autoref{fig:referential}).
+\ie\ along geopotential surfaces (\autoref{fig:referential}).
 Let $(\lambda,\varphi,z)$ be the geographical coordinate system in which a position is defined by
 the latitude $\varphi(i,j)$, the longitude $\lambda(i,j)$ and
@@ -445,5 +447,5 @@
 This is the so-called \textit{vector invariant form} of the momentum advection term.
 For some purposes, it can be advantageous to write this term in the so-called flux form,
-\ie to write it as the divergence of fluxes.
+\ie\ to write it as the divergence of fluxes.
 For example, the first component of \autoref{eq:PE_vector_form} (the $i$-component) is transformed as follows:
 \begin{alignat*}{2}
@@ -484,5 +486,5 @@
 the first one is expressed as the divergence of momentum fluxes (hence the flux form name given to this formulation)
 and the second one is due to the curvilinear nature of the coordinate system used.
-The latter is called the \textit{metric} term and can be viewed as a modification of the Coriolis parameter: 
+The latter is called the \textit{metric} term and can be viewed as a modification of the Coriolis parameter:
 \[
   % \label{eq:PE_cor+metric}
@@ -491,5 +493,5 @@
 
 Note that in the case of geographical coordinate,
-\ie when $(i,j) \to (\lambda,\varphi)$ and $(e_1,e_2) \to (a \, \cos \varphi,a)$,
+\ie\ when $(i,j) \to (\lambda,\varphi)$ and $(e_1,e_2) \to (a \, \cos \varphi,a)$,
 we recover the commonly used modification of the Coriolis parameter $f \to f + (u / a) \tan \varphi$.
 
@@ -508,5 +510,5 @@
                   &+ D_u^{\vect U} + F_u^{\vect U} \\
       \pd[v]{t} = &- (\zeta + f) \, u - \frac{1}{2 e_2} \pd[]{j} (u^2 + v^2)
-                   - \frac{1}{e_3} w \pd[v]{k} - \frac{1}{e_2} \pd[]{j} \lt( \frac{p_s + p_h}{\rho_o} \rt) \\ 
+                   - \frac{1}{e_3} w \pd[v]{k} - \frac{1}{e_2} \pd[]{j} \lt( \frac{p_s + p_h}{\rho_o} \rt) \\
                   &+ D_v^{\vect U} + F_v^{\vect U}
     \end{split}
@@ -540,5 +542,5 @@
   \[
   % \label{eq:w_diag}
-    \pd[w]{k} = - \chi \; e_3 \qquad 
+    \pd[w]{k} = - \chi \; e_3 \qquad
   % \label{eq:hp_diag}
     \pd[p_h]{k} = - \rho \; g \; e_3
@@ -546,5 +548,5 @@
   where the divergence of the horizontal velocity, $\chi$ is given by \autoref{eq:PE_div_Uh}.
 
-\item 
+\item
   \textbf{tracer equations}:
   \begin{equation}
@@ -579,9 +581,9 @@
 Therefore, in order to represent the ocean with respect to
 the first point a space and time dependent vertical coordinate that follows the variation of the sea surface height
-\eg an \zstar-coordinate;
+\eg\ an \zstar-coordinate;
 for the second point, a space variation to fit the change of bottom topography
-\eg a terrain-following or $\sigma$-coordinate;
+\eg\ a terrain-following or $\sigma$-coordinate;
 and for the third point, one will be tempted to use a space and time dependent coordinate that
-follows the isopycnal surfaces, \eg an isopycnic coordinate.
+follows the isopycnal surfaces, \eg\ an isopycnic coordinate.
 
 In order to satisfy two or more constraints one can even be tempted to mixed these coordinate systems, as in
@@ -666,5 +668,5 @@
   \sigma_2 = \frac{1}{e_2} \; \lt. \pd[z]{j} \rt|_s
 \end{equation}
-We also introduce $\omega$, a dia-surface velocity component, defined as the velocity 
+We also introduce $\omega$, a dia-surface velocity component, defined as the velocity
 relative to the moving $s$-surfaces and normal to them:
 \[
@@ -761,5 +763,5 @@
 
 In this case, the free surface equation is nonlinear, and the variations of volume are fully taken into account.
-These coordinates systems is presented in a report \citep{levier.treguier.ea_rpt07} available on the \NEMO web site.
+These coordinates systems is presented in a report \citep{levier.treguier.ea_rpt07} available on the \NEMO\ web site.
 
 The \zstar coordinate approach is an unapproximated, non-linear free surface implementation which allows one to
@@ -784,5 +786,5 @@
 \[
   % \label{eq:PE_zstar_2}
-  \zstar = H \lt( \frac{z - \eta}{H + \eta} \rt) . 
+  \zstar = H \lt( \frac{z - \eta}{H + \eta} \rt) .
 \]
 Since the vertical displacement of the free surface is incorporated in the vertical coordinate \zstar,
@@ -831,5 +833,5 @@
 %end MOM doc %%%
 
-\newpage 
+\newpage
 
 % -------------------------------------------------------------------------------------------------------------
@@ -911,5 +913,5 @@
 In contrast, the ocean will stay at rest in a $z$-model.
 As for the truncation error, the problem can be reduced by introducing the terrain-following coordinate below
-the strongly stratified portion of the water column (\ie the main thermocline) \citep{madec.delecluse.ea_JPO96}.
+the strongly stratified portion of the water column (\ie\ the main thermocline) \citep{madec.delecluse.ea_JPO96}.
 An alternate solution consists of rotating the lateral diffusive tensor to geopotential or to isoneutral surfaces
 (see \autoref{subsec:PE_ldf}).
@@ -929,9 +931,9 @@
 
 The \ztilde -coordinate has been developed by \citet{leclair.madec_OM11}.
-It is available in \NEMO since the version 3.4 and is more robust in version 4.0 than previously. 
+It is available in \NEMO\ since the version 3.4 and is more robust in version 4.0 than previously.
 Nevertheless, it is currently not robust enough to be used in all possible configurations.
 Its use is therefore not recommended.
 
-\newpage 
+\newpage
 
 % ================================================================
@@ -947,5 +949,5 @@
 must be represented entirely in terms of large-scale patterns to close the equations.
 These effects appear in the equations as the divergence of turbulent fluxes
-(\ie fluxes associated with the mean correlation of small scale perturbations).
+(\ie\ fluxes associated with the mean correlation of small scale perturbations).
 Assuming a turbulent closure hypothesis is equivalent to choose a formulation for these fluxes.
 It is usually called the subgrid scale physics.
@@ -991,7 +993,7 @@
 All the vertical physics is embedded in the specification of the eddy coefficients.
 They can be assumed to be either constant, or function of the local fluid properties
-(\eg Richardson number, Brunt-Vais\"{a}l\"{a} frequency, distance from the boundary ...),
+(\eg\ Richardson number, Brunt-Vais\"{a}l\"{a} frequency, distance from the boundary ...),
 or computed from a turbulent closure model.
-The choices available in \NEMO are discussed in \autoref{chap:ZDF}).
+The choices available in \NEMO\ are discussed in \autoref{chap:ZDF}).
 
 % -------------------------------------------------------------------------------------------------------------
@@ -1006,5 +1008,5 @@
 and a sub mesoscale turbulence which is never explicitly solved even partially, but always parameterized.
 The formulation of lateral eddy fluxes depends on whether the mesoscale is below or above the grid-spacing
-(\ie the model is eddy-resolving or not).
+(\ie\ the model is eddy-resolving or not).
 
 In non-eddy-resolving configurations, the closure is similar to that used for the vertical physics.
@@ -1014,5 +1016,5 @@
 (or more precisely neutral surfaces \cite{mcdougall_JPO87}) rather than across them.
 As the slope of neutral surfaces is small in the ocean, a common approximation is to assume that
-the `lateral' direction is the horizontal, \ie the lateral mixing is performed along geopotential surfaces.
+the `lateral' direction is the horizontal, \ie\ the lateral mixing is performed along geopotential surfaces.
 This leads to a geopotential second order operator for lateral subgrid scale physics.
 This assumption can be relaxed: the eddy-induced turbulent fluxes can be better approached by assuming that
@@ -1021,5 +1023,5 @@
 it has components in the three space directions.
 However,
-both horizontal and isoneutral operators have no effect on mean (\ie large scale) potential energy whereas
+both horizontal and isoneutral operators have no effect on mean (\ie\ large scale) potential energy whereas
 potential energy is a main source of turbulence (through baroclinic instabilities).
 \citet{gent.mcwilliams_JPO90} proposed a parameterisation of mesoscale eddy-induced turbulence which
@@ -1065,5 +1067,5 @@
 \end{equation}
 where $r_1$ and $r_2$ are the slopes between the surface along which the diffusive operator acts and
-the model level (\eg $z$- or $s$-surfaces).
+the model level (\eg\ $z$- or $s$-surfaces).
 Note that the formulation \autoref{eq:PE_iso_tensor} is exact for
 the rotation between geopotential and $s$-surfaces,
@@ -1112,5 +1114,5 @@
 (or equivalently the isoneutral thickness diffusivity coefficient),
 and $\tilde r_1$ and $\tilde r_2$ are the slopes between isoneutral and \textit{geopotential} surfaces.
-Their values are thus independent of the vertical coordinate, but their expression depends on the coordinate: 
+Their values are thus independent of the vertical coordinate, but their expression depends on the coordinate:
 \begin{align}
   \label{eq:PE_slopes_eiv}
@@ -1126,5 +1128,5 @@
 This can be achieved in a model by tapering either the eddy coefficient or the slopes to zero in the vicinity of
 the boundaries.
-The latter strategy is used in \NEMO (cf. \autoref{chap:LDF}).
+The latter strategy is used in \NEMO\ (cf. \autoref{chap:LDF}).
 
 \subsubsection{Lateral bilaplacian tracer diffusive operator}
@@ -1148,5 +1150,5 @@
                          - \nabla_h \times \big( A^{lm} \, \zeta \; \vect k \big) \\
                       &= \lt(   \frac{1}{e_1}     \pd[ \lt( A^{lm}    \chi      \rt) ]{i} \rt.
-                              - \frac{1}{e_2 e_3} \pd[ \lt( A^{lm} \; e_3 \zeta \rt) ]{j} , 
+                              - \frac{1}{e_2 e_3} \pd[ \lt( A^{lm} \; e_3 \zeta \rt) ]{j} ,
                                 \frac{1}{e_2}     \pd[ \lt( A^{lm}    \chi      \rt) ]{j}
                          \lt. + \frac{1}{e_1 e_3} \pd[ \lt( A^{lm} \; e_3 \zeta \rt) ]{i} \rt)
@@ -1157,5 +1159,5 @@
 Unfortunately, it is only available in \textit{iso-level} direction.
 When a rotation is required
-(\ie geopotential diffusion in $s$-coordinates or isoneutral diffusion in both $z$- and $s$-coordinates),
+(\ie\ geopotential diffusion in $s$-coordinates or isoneutral diffusion in both $z$- and $s$-coordinates),
 the $u$ and $v$-fields are considered as independent scalar fields, so that the diffusive operator is given by:
 \begin{gather*}
@@ -1167,5 +1169,5 @@
 It is the same expression as those used for diffusive operator on tracers.
 It must be emphasised that such a formulation is only exact in a Cartesian coordinate system,
-\ie on a $f$- or $\beta$-plane, not on the sphere.
+\ie\ on a $f$- or $\beta$-plane, not on the sphere.
 It is also a very good approximation in vicinity of the Equator in
 a geographical coordinate system \citep{lengaigne.madec.ea_JGR03}.